summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorLars Wirzenius <liw@liw.fi>2012-05-12 12:07:40 +0100
committerLars Wirzenius <liw@liw.fi>2012-05-12 12:07:40 +0100
commitdcd33d3089bec1de05a96839d49e3bb586b918ad (patch)
treec01b82e1b8b62e5796fd6036b5e5d0714c179497
parent836e749824673b00c084e7f4361427edab1199fe (diff)
downloadsummain-dcd33d3089bec1de05a96839d49e3bb586b918ad.tar.gz
Bug fix: fail if filename given on command line does not exist
-rw-r--r--NEWS6
-rwxr-xr-xsummain2
-rw-r--r--tests/fails-on-nonexistent-root.exit1
-rwxr-xr-xtests/fails-on-nonexistent-root.script24
-rw-r--r--tests/fails-on-nonexistent-root.stderr1
5 files changed, 34 insertions, 0 deletions
diff --git a/NEWS b/NEWS
index 4687d4c..f1138f6 100644
--- a/NEWS
+++ b/NEWS
@@ -2,6 +2,12 @@ NEWS file for summain
=====================
+Version 0.13, released UNRELEASED
+---------------------------------
+
+* Bug fix: Summain now fails if the filename given on the command line
+ does not exist.
+
Version 0.12, released 2012-02-25
---------------------------------
diff --git a/summain b/summain
index b82c108..55bb855 100755
--- a/summain
+++ b/summain
@@ -128,6 +128,8 @@ class Summain(cliapp.Application):
dirnames.sort()
for filename in sorted(filenames):
yield os.path.join(dirname, filename)
+ elif not os.path.exists(root):
+ raise cliapp.AppException('Does not exist: %s' % root)
else:
yield root
diff --git a/tests/fails-on-nonexistent-root.exit b/tests/fails-on-nonexistent-root.exit
new file mode 100644
index 0000000..d00491f
--- /dev/null
+++ b/tests/fails-on-nonexistent-root.exit
@@ -0,0 +1 @@
+1
diff --git a/tests/fails-on-nonexistent-root.script b/tests/fails-on-nonexistent-root.script
new file mode 100755
index 0000000..aa03bac
--- /dev/null
+++ b/tests/fails-on-nonexistent-root.script
@@ -0,0 +1,24 @@
+#!/bin/sh
+# Copyright 2012 Lars Wirzenius
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+
+set -u
+
+
+"$SRCDIR/summain" "$DATADIR/does-not-exist" 2> "$DATADIR/stderr"
+exit=$?
+sed "s,$DATADIR,TMP,g" "$DATADIR/stderr" 1>&2
+exit $exit
diff --git a/tests/fails-on-nonexistent-root.stderr b/tests/fails-on-nonexistent-root.stderr
new file mode 100644
index 0000000..6a9fc7d
--- /dev/null
+++ b/tests/fails-on-nonexistent-root.stderr
@@ -0,0 +1 @@
+ERROR: Does not exist: TMP/does-not-exist